﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace SpellCaster3.Core
{
    public class MoveEventArgs : EventArgs
    {
        private Point? _LastLocation;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="lastLocation">Must be set only if location has changed</param>
        public MoveEventArgs(Point? lastLocation)
        {
            _LastLocation = lastLocation;
        }

        public bool IsLocationChanged { get { return _LastLocation.HasValue; } }

        /// <summary>
        /// Item set only if location has changed
        /// </summary>
        public Point? LastLocation { get { return _LastLocation; } }

        /// <summary>
        /// If you want cancel the movement, set this to true
        /// </summary>
        public bool Cancel { get; set; }
    }
}
